window.addEventListener('DOMContentLoaded', function() {
  // First, tell the user that something's happening
  var loading = document.createElement('p');
  loading.innerHTML = 'Loading...';
  document.body.appendChild(loading);

  // Get the headlines from the background process
  var redditText = opera.extension.bgProcess.doXHR('http://api.reddit.com/');

  // Stop if there's an error
  try {
    // Create a JSON object and get the array of stories within it
    var redditObj = JSON.parse(redditText);
    var stories = redditObj.data.children;
  } catch(e) {
    loading.innerHTML = 'Problem fetching the headlines';
    return;
  }

  // Create a list element and prepare variables for its items
  var list = document.createElement('ol');
  var story, item;

  // Loop through the array of stories and add each one to the list
  for (var i = 0, len = stories.length; i < len; i++) {
    story = stories[i].data;
    item = document.createElement('li');
    item.innerHTML = '<a href="' + story.url + '">' + story.title + '</a>';
    list.appendChild(item);
  }

  // Finally, remove the loading message and show the list of headlines
  document.body.removeChild(loading);
  document.body.appendChild(list);
}, false);
